Bug 143081 - CAN-2004-1287 Bernstein class reports buffer overflow in nasm
Summary: CAN-2004-1287 Bernstein class reports buffer overflow in nasm
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: nasm
Version: 3.0
Hardware: All
OS: Linux
medium
low
Target Milestone: ---
Assignee: Richard Henderson
QA Contact: Brian Brock
URL:
Whiteboard: impact=low,public=20041215,source=bug...
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2004-12-16 13:10 UTC by Josh Bressers
Modified: 2007-11-30 22:07 UTC (History)
0 users

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2005-05-04 15:01:17 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2005:381 normal SHIPPED_LIVE Low: nasm security update 2005-05-04 04:00:00 UTC

Description Josh Bressers 2004-12-16 13:10:37 UTC
http://tigger.uic.edu/~jlongs2/holes/nasm.txt

Jonathan Rockway, a student in my Fall 2004 UNIX Security Holes course,
has discovered a remotely exploitable security hole in NASM. I'm
publishing this notice, but all the discovery credits should be assigned
to Rockway.

You are at risk if you receive an asm file from an email message (or a
web page or any other source that could be controlled by an attacker)
and feed that file through NASM. Whoever provides that asm file then has
complete control over your account: he can read and modify your files,
watch the programs you're running, etc.

Of course, if you _run_ a program, you're authorizing the programmer to
take control of your account; but the NASM documentation does not say
that merely _assembling_ a program can have this effect. It's easy to
imagine situations in which a program is run inside a jail but assembled
outside the jail; this NASM bug means that the jail is ineffective.

Proof of concept: On an x86 computer running FreeBSD 4.10, as root, type

   cd /usr/ports/devel/nasm
   make install

to download and compile the NASM program, version 0.98.38 (current).
Then, as any user, save the file 22.S attached to this message, and type

   nasm 22.S

with the unauthorized result that a file named EXPLOITED is created in
the current directory. (I tested this with a 525-byte environment, as
reported by printenv | wc -c.)

Here's the bug: In preproc.c, error() uses an unprotected vsprintf() to
copy data into a 1024-byte buff[] array.

---D. J. Bernstein, Associate Professor, Department of Mathematics,
Statistics, and Computer Science, University of Illinois at Chicago

Comment 1 Josh Bressers 2004-12-16 13:15:20 UTC
This issue also affects RHEL2.1

Comment 2 Jindrich Novy 2005-04-15 12:25:18 UTC
Affects RHEL4 as well.

Comment 3 Jindrich Novy 2005-04-15 12:53:05 UTC
This issue doesn't affect RHEL 2.1 as the vsprintf in preproc.c/error() is
missing completely in nasm-0.98-8.

Comment 4 Jindrich Novy 2005-04-15 13:08:31 UTC
Fix for this is now applied in RHEL3 and RHEL4.

Comment 5 Josh Bressers 2005-05-04 15:01:17 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-381.html



Note You need to log in before you can comment on or make changes to this bug.